org.apache.ignite.mxbean

## Interface IgniteMXBean

All Known Implementing Classes:
  IgniteKernal

    @MXBeanDescription(value="MBean that provides access to Kernal information.")
    public interface IgniteMXBean

This interface defines JMX view on kernal.

### Method Summary

All Methods Instance Methods Abstract Methods
`boolean` `active()` Checks if Ignite grid is active.
`void` `active(boolean active)`
`void` `clearNodeLocalMap()` Clears node local map.
`void` `dumpDebugInfo()` Dumps debug information for the current node.
`String` `executeTask(String taskName, String arg)` A shortcut method that executes given task assuming single `java.lang.String` argument and `java.lang.String` return type.
`String` `getCheckpointSpiFormatted()` Gets a formatted instance of configured checkpoint SPI implementation.
`String` `getCollisionSpiFormatted()` Gets a formatted instance of configured collision SPI implementations.
`String` `getCommunicationSpiFormatted()` Gets a formatted instance of fully configured SPI communication implementation.
`String` `getCopyright()` Gets copyright statement for Ignite product.
`String` `getCurrentCoordinatorFormatted()` Gets a formatted properties of current coordinator.
`String` `getDeploymentSpiFormatted()` Gets a formatted instance of fully configured deployment SPI implementation.
`String` `getDiscoverySpiFormatted()` Gets a formatted instance of configured discovery SPI implementation.
`String` `getEventStorageSpiFormatted()` Gets a formatted instance of fully configured event SPI implementation.
`String` `getExecutorServiceFormatted()` Gets a formatted instance of fully configured thread pool that is used in grid.
`String` `getFailoverSpiFormatted()` Gets a formatted instance of fully configured failover SPI implementations.
`String` `getFullVersion()` Gets string presentation of the version.
`String` `getGridLoggerFormatted()` Gets a formatted instance of logger that is in grid.
`String` `getIgniteHome()` Gets Ignite installation home folder.
`String` `getInstanceName()` Gets optional kernal instance name.
`String` `getJdkInformation()` Gets JDK information.
`List<String>` `getLifecycleBeansFormatted()` Gets `toString()` representation of of lifecycle beans configured with Ignite.
`String` `getLoadBalancingSpiFormatted()` Gets a formatted instance of fully configured load balancing SPI implementations.
`UUID` `getLocalNodeId()` Unique identifier for this node within grid.
`Map<Long,Long>` `getLongJVMPauseLastEvents()` Gets long JVM pause last events.
`long` `getLongJVMPausesCount()` Gets long JVM pauses count.
`long` `getLongJVMPausesTotalDuration()` Gets long JVM pauses total duration.
`String` `getMBeanServerFormatted()` Gets a formatted instance of MBean server instance.
`String` `getOsInformation()` Gets OS information.
`String` `getOsUser()` Gets OS user.
`long` `getStartTimestamp()` Get start timestamp of the kernal.
`String` `getStartTimestampFormatted()` Gets string presentation of the kernal start timestamp.
`long` `getUpTime()` Gets up-time of the kernal.
`String` `getUpTimeFormatted()` Gets string presentation of up-time for the kernal.
`List<String>` `getUserAttributesFormatted()` Gets a list of formatted user-defined attributes added to this node.
`String` `getVmName()` Gets VM name.
`boolean` `isNodeInBaseline()` Gets a flag whether local node is in baseline.
`boolean` `isPeerClassLoadingEnabled()` Returns `true` if peer class loading is enabled, `false` otherwise.
`boolean` `isRebalanceEnabled()` Gets rebalance enabled flag.
`boolean` `pingNode(String nodeId)` Pings node with given node ID to see whether it is alive.
`boolean` `pingNodeByAddress(String host)` Pings node with given host name to see if it is alive.
`void` `printLastErrors()` Prints errors.
`void` `rebalanceEnabled(boolean rebalanceEnabled)` Enable or disable cache partition rebalance per node.
`boolean` `removeCheckpoint(String key)` This method allows manually remove the checkpoint with given `key`.
`void` `runIoTest(long warmup, long duration, int threads, long maxLatency, int rangesCnt, int payLoadSize, boolean procFromNioThread)` Runs IO latency test against all remote server nodes in cluster.
`void` `undeployTaskFromGrid(String taskName)` Makes the best attempt to undeploy a task from the whole grid.

### Method Detail

#### getFullVersion

    @MXBeanDescription(value="String presentation of the Ignite version.")
    String getFullVersion()

Gets string presentation of the version.

Returns:
  String presentation of the version.

#### getCopyright

    @MXBeanDescription(value="Copyright statement for Ignite product.")
    String getCopyright()

Gets copyright statement for Ignite product.

Returns:
  Copyright statement for Ignite product.

#### getStartTimestampFormatted

    @MXBeanDescription(value="String presentation of the kernal start timestamp.")
    String getStartTimestampFormatted()

Gets string presentation of the kernal start timestamp.

Returns:
  String presentation of the kernal start timestamp.

#### isRebalanceEnabled

    @MXBeanDescription(value="Rebalance enabled flag.")
    boolean isRebalanceEnabled()

Gets rebalance enabled flag.

Returns:
  Rebalance enabled flag.

#### rebalanceEnabled

    @MXBeanParametersDescriptions(value={"Enable cache partitions rebalance on node.","Disable cache partitions rebalance on node."})
    void rebalanceEnabled(boolean rebalanceEnabled)

Enable or disable cache partition rebalance per node.

Parameters:
  `rebalanceEnabled` - If `true` then set rebalance to enabled state.

#### getUpTimeFormatted

    @MXBeanDescription(value="String presentation of up-time for the kernal.")
    String getUpTimeFormatted()

Gets string presentation of up-time for the kernal.

Returns:
  String presentation of up-time for the kernal.

#### getStartTimestamp

    @MXBeanDescription(value="Start timestamp of the kernal.")
    long getStartTimestamp()

Get start timestamp of the kernal.

Returns:
  Start timestamp of the kernal.

#### getUpTime

    @MXBeanDescription(value="Up-time of the kernal.")
    long getUpTime()

Gets up-time of the kernal.

Returns:
  Up-time of the kernal.

#### getLongJVMPausesCount

    @MXBeanDescription(value="Long JVM pauses count.")
    long getLongJVMPausesCount()

Gets long JVM pauses count.

Returns:
  Long JVM pauses count.

#### getLongJVMPausesTotalDuration

    @MXBeanDescription(value="Long JVM pauses total duration.")
    long getLongJVMPausesTotalDuration()

Gets long JVM pauses total duration.

Returns:
  Long JVM pauses total duration.

#### getLongJVMPauseLastEvents

    @MXBeanDescription(value="Long JVM pause last events.")
    Map<Long,Long> getLongJVMPauseLastEvents()

Gets long JVM pause last events.

Returns:
  Long JVM pause last events.

#### getUserAttributesFormatted

    @MXBeanDescription(value="Collection of formatted user-defined attributes added to this node.")
    List<String> getUserAttributesFormatted()

Gets a list of formatted user-defined attributes added to this node.

Note that grid will add all System properties and environment properties to grid node attributes also. SPIs may also add node attributes that are used for SPI implementation.

Returns:
  User defined attributes for this node.

#### getGridLoggerFormatted

    @MXBeanDescription(value="Formatted instance of logger that is in grid.")
    String getGridLoggerFormatted()

Gets a formatted instance of logger that is in grid.

Returns:
  Logger that is used in grid.

#### getExecutorServiceFormatted

    @MXBeanDescription(value="Formatted instance of fully configured thread pool that is used in grid.")
    String getExecutorServiceFormatted()

Gets a formatted instance of fully configured thread pool that is used in grid.

Returns:
  Thread pool implementation that is used in grid.

#### getIgniteHome

    @MXBeanDescription(value="Ignite installation home folder.")
    String getIgniteHome()

Gets Ignite installation home folder.

Returns:
  Ignite installation home.

#### getMBeanServerFormatted

    @MXBeanDescription(value="Formatted instance of MBean server instance.")
    String getMBeanServerFormatted()

Gets a formatted instance of MBean server instance.

Returns:
  MBean server instance.

#### getLocalNodeId

    @MXBeanDescription(value="Unique identifier for this node within grid.")
    UUID getLocalNodeId()

Unique identifier for this node within grid.

Returns:
  Unique identifier for this node within grid.

#### isPeerClassLoadingEnabled

    @MXBeanDescription(value="Whether or not peer class loading (a.k.a. P2P class loading) is enabled.")
    boolean isPeerClassLoadingEnabled()

Returns `true` if peer class loading is enabled, `false` otherwise. Default value is `true`.

When peer class loading is enabled and task is not deployed on local node, local node will try to load classes from the node that initiated task execution. This way, a task can be physically deployed only on one node and then internally penetrate to all other nodes.

Returns:
  `true` if peer class loading is enabled, `false` otherwise.

#### getLifecycleBeansFormatted

    @MXBeanDescription(value="String representation of lifecycle beans.")
    List<String> getLifecycleBeansFormatted()

Gets `toString()` representation of of lifecycle beans configured with Ignite.

Returns:
  `toString()` representation of all lifecycle beans configured with Ignite.

#### removeCheckpoint

    @MXBeanDescription(value="This method allows manually remove the checkpoint with given key. Return true if specified checkpoint was indeed removed, false otherwise.")
     @MXBeanParametersNames(value="key")
     @MXBeanParametersDescriptions(value="Checkpoint key to remove.")
    boolean removeCheckpoint(String key)

This method allows manually remove the checkpoint with given `key`.

Parameters:
  `key` - Checkpoint key.
Returns:
  `true` if specified checkpoint was indeed removed, `false` otherwise.

#### pingNode

    @MXBeanDescription(value="Pings node with given node ID to see whether it is alive. Returns whether or not node is alive.")
     @MXBeanParametersNames(value="nodeId")
     @MXBeanParametersDescriptions(value="String presentation of node ID. See java.util.UUID class for details.")
    boolean pingNode(String nodeId)

Pings node with given node ID to see whether it is alive.

Parameters:
  `nodeId` - String presentation of node ID. See `UUID.fromString(String)` for details on string formatting.
Returns:
  Whether or not node is alive.

#### active

    @MXBeanDescription(value="Execute activate or deactivate process.")
     @MXBeanParametersNames(value="active")
    void active(boolean active)

Parameters:
  `active` - Activate/DeActivate flag.

#### active

    @MXBeanDescription(value="Checks Ignite grid is active or is not active.")
    boolean active()

Checks if Ignite grid is active. If Ignite grid is not active return `False`.

Returns:
  `True` if grid is active. `False` If grid is not active.

#### undeployTaskFromGrid

    @MXBeanDescription(value="Makes the best attempt to undeploy a task from the whole grid.")
     @MXBeanParametersNames(value="taskName")
     @MXBeanParametersDescriptions(value="Name of the task to undeploy.")
    void undeployTaskFromGrid(String taskName)
                                                                                                                                                                                                                                  throws JMException

Makes the best attempt to undeploy a task from the whole grid. Note that this method returns immediately and does not wait until the task will actually be undeployed on every node.

Note that Ignite maintains internal versions for grid tasks in case of redeployment. This method will attempt to undeploy all versions on the grid task with given name.

Parameters:
  `taskName` - Name of the task to undeploy. If task class has `ComputeTaskName` annotation, then task was deployed under a name specified within annotation. Otherwise, full class name should be used as task's name.
Throws:
  `JMException` - Thrown if undeploy failed.

#### executeTask

    @MXBeanDescription(value="A shortcut method that executes given task assuming single String argument and String return type. Returns Task return value (assumed of String type).")
     @MXBeanParametersNames(value={"taskName","arg"})
     @MXBeanParametersDescriptions(value={"Name of the task to execute.","Single task execution argument (can be null)."})
    String executeTask(String taskName,
                                                                                                                                                                                                                                                                                                                                                                                   String arg)
                                                                                                                                                                                                                                                                                                                                                                            throws JMException

A shortcut method that executes given task assuming single `java.lang.String` argument and `java.lang.String` return type.

Parameters:
  `taskName` - Name of the task to execute.
  `arg` - Single task execution argument (can be `null`).
Returns:
  Task return value (assumed of `java.lang.String` type).
Throws:
  `JMException` - Thrown in case when execution failed.

#### pingNodeByAddress

    @MXBeanDescription(value="Pings node with given host name to see if it is alive. Returns whether or not node is alive.")
     @MXBeanParametersNames(value="host")
     @MXBeanParametersDescriptions(value="Host name or IP address of the node to ping.")
    boolean pingNodeByAddress(String host)

Pings node with given host name to see if it is alive.

Parameters:
  `host` - Host name or IP address of the node to ping.
Returns:
  Whether or not node is alive.

#### getDiscoverySpiFormatted

    @MXBeanDescription(value="Formatted instance of configured discovery SPI implementation.")
    String getDiscoverySpiFormatted()

Gets a formatted instance of configured discovery SPI implementation.

Returns:
  Grid discovery SPI implementation.

#### getCommunicationSpiFormatted

    @MXBeanDescription(value="Formatted instance of fully configured SPI communication implementation.")
    String getCommunicationSpiFormatted()

Gets a formatted instance of fully configured SPI communication implementation.

Returns:
  Grid communication SPI implementation.

#### getDeploymentSpiFormatted

    @MXBeanDescription(value="Formatted instance of fully configured deployment SPI implementation.")
    String getDeploymentSpiFormatted()

Gets a formatted instance of fully configured deployment SPI implementation.

Returns:
  Grid deployment SPI implementation.

#### getCheckpointSpiFormatted

    @MXBeanDescription(value="Formatted instance of configured checkpoint SPI implementation.")
    String getCheckpointSpiFormatted()

Gets a formatted instance of configured checkpoint SPI implementation.

Returns:
  Grid checkpoint SPI implementation.

#### getCollisionSpiFormatted

    @MXBeanDescription(value="Formatted instance of configured collision SPI implementations.")
    String getCollisionSpiFormatted()

Gets a formatted instance of configured collision SPI implementations.

Returns:
  Grid collision SPI implementations.

#### getEventStorageSpiFormatted

    @MXBeanDescription(value="Formatted instance of fully configured event SPI implementation.")
    String getEventStorageSpiFormatted()

Gets a formatted instance of fully configured event SPI implementation.

Returns:
  Grid event SPI implementation.

#### getFailoverSpiFormatted

    @MXBeanDescription(value="Formatted instance of fully configured failover SPI implementations.")
    String getFailoverSpiFormatted()

Gets a formatted instance of fully configured failover SPI implementations.

Returns:
  Grid failover SPI implementations.

#### getLoadBalancingSpiFormatted

    @MXBeanDescription(value="Formatted instance of fully configured load balancing SPI implementations.")
    String getLoadBalancingSpiFormatted()

Gets a formatted instance of fully configured load balancing SPI implementations.

Returns:
  Grid load balancing SPI implementations.

#### getOsInformation

    @MXBeanDescription(value="OS information.")
    String getOsInformation()

Gets OS information.

Returns:
  OS information.

#### getJdkInformation

    @MXBeanDescription(value="JDK information.")
    String getJdkInformation()

Gets JDK information.

Returns:
  JDK information.

#### getOsUser

    @MXBeanDescription(value="OS user name.")
    String getOsUser()

Gets OS user.

Returns:
  OS user name.

#### getVmName

    @MXBeanDescription(value="VM name.")
    String getVmName()

Gets VM name.

Returns:
  VM name.

#### getInstanceName

    @MXBeanDescription(value="Optional kernal instance name.")
    String getInstanceName()

Gets optional kernal instance name. It can be `null`.

Returns:
  Optional kernal instance name.

#### printLastErrors

    @MXBeanDescription(value="Prints last suppressed errors.")
    void printLastErrors()

Prints errors.

#### dumpDebugInfo

    @MXBeanDescription(value="Dumps debug information for the current node.")
    void dumpDebugInfo()

Dumps debug information for the current node.

#### getCurrentCoordinatorFormatted

    @MXBeanDescription(value="Formatted properties of current coordinator.")
    String getCurrentCoordinatorFormatted()

Gets a formatted properties of current coordinator.

#### isNodeInBaseline

    @MXBeanDescription(value="Baseline node flag.")
    boolean isNodeInBaseline()

Gets a flag whether local node is in baseline. Returns false if baseline topology is not established.

Returns:
  Return a baseline flag.

#### runIoTest

    @MXBeanDescription(value="Runs IO latency test against all remote server nodes in cluster.")
     @MXBeanParametersNames(value={"warmup","duration","threads","maxLatency","rangesCnt","payLoadSize","procFromNioThread"})
     @MXBeanParametersDescriptions(value={"Warmup duration (millis).","Test duration (millis).","Threads count.","Maximum latency expected (nanos).","Ranges count for histogram.","Payload size (bytes).","Process requests in NIO-threads flag."})
    void runIoTest(long warmup,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           long duration,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           int threads,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           long maxLatency,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           int rangesCnt,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           int payLoadSize,
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           boolean procFromNioThread)

Runs IO latency test against all remote server nodes in cluster.

Parameters:
  `warmup` - Warmup duration in milliseconds.
  `duration` - Test duration in milliseconds.
  `threads` - Thread count.
  `maxLatency` - Max latency in nanoseconds.
  `rangesCnt` - Ranges count in resulting histogram.
  `payLoadSize` - Payload size in bytes.
  `procFromNioThread` - `True` to process requests in NIO threads.

#### clearNodeLocalMap

    @MXBeanDescription(value="Clears local node map.")
    void clearNodeLocalMap()

Clears node local map.

${current.year} Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Database and Caching Platform | : ver. 2.7.6
Release Date | : September 11 2019